



# O365
  
Connect to to your Outlook email account and Sharepoint workspace.  

*Read this in other languages: [English](README.md), [Português](README.pr.md), [Español](README.es.md)*

## How to install this module
  
To install the module in Rocketbot Studio, it can be done in two ways:
1. Manual: __Download__ the .zip file and unzip it in the modules folder. The folder name must be the same as the module and inside it must have the following files and folders: \__init__.py, package.json, docs, example and libs. If you have the application open, refresh your browser to be able to use the new module.
2. Automatic: When entering Rocketbot Studio on the right margin you will find the **Addons** section, select **Install Mods**, search for the desired module and press install.  


## Overview


1. Connect to O365  
Connect to O365 application instance

2. List all emails  
List all email, you can specify a filter

3. List unread emails  
List all unread emails from your mailbox

4. Read email for ID  
Read an email usign its ID

5. Send Email  
Send an email

6. Reply Email  
Reply an email using its ID

7. Forward Email  
Forward an email using its ID

8. Download attachments  
Download attached files from an email

9. Mark as unread  
Mark an email as unread

10. Download .eml  
Download an email in .eml format

11. Email folders list  
List of email folders

12. Move email  
Move an email from one folder to another

13. Create folder  
Creates a new folder in the email

14. Get groups  
Get the list of Groups that the account is part of

15. Get group  
Get Group by its ID

16. Get site  
Get the site of the Group

17. Get site lists  
Get the lists of the Site

18. Get list columns  
Get the editable columns of a specific List of the Site

19. Create List  
Create a new list

20. Get list Items  
Get the items of a List using its name

21. Get Item  
Get an Item, using its ID, from a List

22. Create Item  
Create an Item in a List

23. Delete Item  
Delete an Item, using its ID, from a List

24. Update Item  
Update an Item data using its ID

25. Get document libraries  
Get a list of the Document Libraries within the Site

26. Get documents  
Get a list of the documents within a library

27. Upload document  
Upload a document to a Site library

28. Download or modify document  
Upload a document to a Site library  




----
### OS

- windows
- mac
- linux
- docker

### Dependencies
- [**bs4**](https://pypi.org/project/bs4/)- [**O365**](https://pypi.org/project/O365/)
### License
  
![MIT](https://camo.githubusercontent.com/107590fac8cbd65071396bb4d04040f76cde5bde/687474703a2f2f696d672e736869656c64732e696f2f3a6c6963656e73652d6d69742d626c75652e7376673f7374796c653d666c61742d737175617265)  
[MIT](http://opensource.org/licenses/mit-license.ph)